<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.aip"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <div *ngIf="readonly"
         class="header"
    >
      <solidify-status *ngIf="getFormControl(formDefinition.status) as fd"
                       [statusModel]="enumUtil.getKeyValue(packageStatusEnumValuesTranslate, fd.value)"
      ></solidify-status>
    </div>

    <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.organizationalUnitId) as fd"
                                       [formControl]="fd"
                                       [labelKey]="'name'"
                                       [placeholder]="labelTranslateEnum.organizationalUnit | translate"
                                       [readonly]="true"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedOrgUnitActionNameSpace"
                                       [state]="sharedOrgUnitState"
                                       [valueKey]="'resId'"
                                       solidifyValidation
    >
    </solidify-searchable-single-select>

    <mat-form-field *ngIf="getFormControl(formDefinition.resId) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.resId | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

  </ng-template>

  <ng-template #rightTemplate>

    <div class="access-level-wrapper">
      <dlcm-shared-access-level [accessLevel]="getFormControl(formDefinition.access)?.value"
                                class="icon"
      ></dlcm-shared-access-level>
      <mat-form-field *ngIf="getFormControl(formDefinition.access) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.accessLevel | translate }}</mat-label>
        <mat-select [formControl]="fd"
        >
          <mat-option *ngFor="let accessLevel of accessEnumValues"
                      [value]="accessLevel.key"
                      solidifyTooltipOnEllipsis
          >
            {{accessLevel.value | translate}}
          </mat-option>
        </mat-select>
      </mat-form-field>
    </div>

    <dlcm-shared-data-sensitivity-input [formControl]="getFormControl(formDefinition.dataSensitivity)"></dlcm-shared-data-sensitivity-input>

    <solidify-panel-expandable *ngIf="getFormControl(formDefinition.embargoAccess)?.value | isNotNullNorUndefined"
                               [isOpen]="true"
                               [titleToTranslate]="labelTranslateEnum.archiveEmbargo | translate"
                               class="section-embargo"
    >
      <ng-container *ngIf="getFormControl(formDefinition.embargoAccess) as fd">
        <div *ngIf="fd?.value"
             class="access-level-embargo-wrapper"
        >
          <dlcm-shared-access-level [accessLevel]="fd?.value"
                                    class="icon"
          ></dlcm-shared-access-level>
          <mat-form-field [appearance]="appearanceInputMaterial"
                          [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{labelTranslateEnum.embargoAccessLevel | translate }}</mat-label>
            <mat-select [value]="fd?.value"
                        disabled
            >
              <mat-option *ngFor="let accessLevel of accessEnumValues"
                          [value]="accessLevel.key"
                          solidifyTooltipOnEllipsis
              >
                {{accessLevel.value | translate}}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>
      </ng-container>

      <ng-container *ngIf="getFormControl(formDefinition.embargoNumberMonths) as fd">
        <mat-form-field *ngIf="fd.value"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.embargoDuration | translate}}</mat-label>
          <input [value]="fd.value"
                 disabled
                 matInput
          >
        </mat-form-field>
      </ng-container>

      <ng-container *ngIf="getFormControl(formDefinition.embargoStartDate) as fd">
        <mat-form-field *ngIf="fd.value"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.embargoStartDate | translate}}</mat-label>
          <input [value]="fd.value"
                 disabled
                 matInput
          >
        </mat-form-field>
      </ng-container>
    </solidify-panel-expandable>

    <dlcm-shared-compliance-level-rating [formControl]="getFormControl(formDefinition.complianceLevel)"></dlcm-shared-compliance-level-rating>

    <dlcm-shared-package-button-navigator [currentViewMode]="'dip'"
                                          [aipId]="model?.aipIds?.length > 0 ? model.aipIds[0] : undefined"
                                          [dipId]="model?.resId"
    >
    </dlcm-shared-package-button-navigator>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
